<?php

/**
 * com_dmenu
 *
 * @version 1.0
 * @author Creative Pulse
 * @copyright Creative Pulse 2011
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @link http://www.creativepulse.eu
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


$mainframe->set('JComponentTitle', '<div class="header" style="padding:0">' . JText::_('DMenu') . ' - ' . JText::_('Help') . '</div>');

$document =& JFactory::getDocument();
$document->addStyleSheet('components/' . $option . '/css/main.css');

?>
<div id="credits">
	<h3>DMenu v1.0</h3>
	<p>
		<span class="type_title">License</span>: GNU / GPLv2
		<br/><span class="type_title">Copyright</span>: (C)2011 Creative Pulse
		<br/><span class="type_title">Website</span>: <a href="http://www.creativepulse.eu">http://www.creativepulse.eu</a>
	</p>

	<p>
		Created by Creative Pulse
		<br/><a href="http://www.creativepulse.eu">http://www.creativepulse.eu</a>
	</p>
</div>

<h2>Introduction</h2>

<p>DMenu is a menu that adds functionality to create an impressive and useful user experience.
You can use DMenu to show a regular Joomla! menu. If you want to take it up a notch you can
add custom text using a rich text editor (like TinyMCE) and make your custom content appear
in the place of a regular menu item. You may also display a module position inside the panel
of a regular menu item.</p>

<p>DMenu initially appears as a regular menu and when clicked it shows sub-menus in a unified
space. Each menu item appears in a form of a card that sits on top of other cards. This is
how it is modelled in code level and this is how it takes its name: Deck of cards Menu.</p>

<p>What makes DMenu unique is its design to integrate well with smartphones and tablets. It
does that simply by responding to clicks with the same ease as with mouse over/out events.
So smartphone and tablet users tap and access the menu without the need of a mouse. And all
this works with smooth animations.</p>


<h2>How to control DMenu</h2>

<p>DMenu is based on a regular Joomla! menu, so the first and vital step to set it up is to
create a simple Joomla! menu. You will need two levels of menu items. The first level will
appear as tags in the page. When these tags are clicked and they have a custom text or
sub-items, a sub-menu appears.</p>

<p>You need the DMenu component only when you want to override a menu item with custom text.
The component is also useful to help you find URL links for specific menu items.</p>

<p>Why so much fuss with menu items? In Joomla! a menu item is a way to control pages and
modules. Each menu item has a unique ID which is shown as the "Itemid" parameter in your
URLs. The DMenu component is designed to help you find the URLs with the necessary
information that makes Joomla! work smoothly.</p>


<h2>How to add/edit/delete custom text in a menu item</h2>

<p>Go to the DMenu component (do not confuse that with the DMenu module), use the sliding
panels to open a menu group and simply click on a menu item.</p>

<p>When you click on a menu item you can see the text editor. Enter your custom content and
click the Save button.</p>

<p>You can tell if a menu item has custom content when you see its menu items (in the sliding
panels on the left) in a bold typeface.</p>

<p>To delete a custom content follow the same process to select the menu item and click the
Delete button.</p>


<h2>How to add/edit/delete module positions in a menu item</h2>

<p>This is simple. It may seem a little tricky for the first time you do it but then it gets easy.</p>

<p>Edit or create a menu item of type "External URL". In the address box type ::showmod::id=xxx where
you should replace xxx with the name of the module position. Example: ::showmod::id=myid</p>

<p>You can use a similar way to display a module as a sub-level in a custom text. Create a link
and in the link URL type ::showmod::id=xxx</p>


<h2>How to find extra help</h2>

<p>You can ask your questions at our website <a href="http://www.creativepulse.eu" target="_blank">http://www.creativepulse.eu</a> .</p>

<p>If you are looking for professional templates built for DMenu visit <a href="http://www.bonusthemes.com" target="_blank">http://www.bonusthemes.com</a> .</p>

