<?php

/**
 * com_dmenu
 *
 * @version 1.0
 * @author Creative Pulse
 * @copyright Creative Pulse 2011
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @link http://www.creativepulse.eu
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


$mainframe->set('JComponentTitle', '<div class="header" style="padding:0">' . JText::_('DMenu') . ' - ' . JText::_('Data input') . '</div>');

$document =& JFactory::getDocument();
$document->addStyleSheet('components/' . $option . '/css/main.css');

function json_esc($input, $esc_lt_gt = true) {
	$result = '';
	$input = (string) $input;
	$conv = array( "'" => "'", '"' => '"', '&' => '&', '\\' => '\\', "\n" => 'n', "\r" => 'r', "\t" => 't', "\b" => 'b', "\f" => 'f' );

	if ($esc_lt_gt) {
		$conv = array_merge($conv, array( '<' => 'u003C', '>' => 'u003E' ));
	}

	for ($i = 0, $len = strlen($input); $i < $len; $i++) {
		$result .= isset($conv[$input{$i}]) ? '\\' . $conv[$input[$i]] : $input[$i];
	}

	return $result;
}

require_once(JPATH_SITE . '/includes/application.php');
function load_menu_item($item) {
	$result = array(
		'type' => 'text', // text, link, link_new, link_popup, separator
		'name' => $item->name,
		'link' => '',
		'href' => '',
		'image' => '',
		'selection' => 0, // 0 = none, 1 = parent, 2 = current
	);

	// Menu Link is a special type that is a link to another item
	if ($item->type == 'menulink') {
		$target_id = 0;

		if (!empty($item->params)) {
			$source_params = new JParameter($item->params);
			$target_id = $source_params->get('menu_item', 0);
		}

		if ($target_id == 0 && preg_match('/Itemid=([0-9]+)/', $item->link, $m)) {
			$target_id = intval($m[1]);
		}

		if ($target_id > 0) {
			$menu = &JSite::getMenu();
			if ($tmp = $menu->getItem($target_id)) {
				$item = $tmp;
			}
		}
	}

	static $path = false;
	if ($path === false) {
		$menu = &JSite::getMenu();
		$active = $menu->getActive();
		$path = isset($active) ? array_reverse($active->tree) : null;
	}

	if (!is_array($path) || empty($path)) {
		// ignore cases
	}
	else if ($path[0] == $item->id) {
		$result['selection'] = 2;
	}
	else if (in_array($item->id, $path)) {
		$result['selection'] = 1;
	}

	$iParams = new JParameter($item->params);
	if ($iParams->get('menu_image') && $iParams->get('menu_image') != -1) {
		$result['image'] = '<img src="'.JURI::base(true).'/images/stories/'.$iParams->get('menu_image').'" alt="" border="0" />';
	}

	switch ($item->type) {
		case 'separator' :
			$result['type'] = 'separator';
			break;

		case 'url' :
			if ((strpos($item->link, 'index.php?') !== false) && (strpos($item->link, 'Itemid=') === false)) {
				$item->url = $item->link.'&amp;Itemid='.$item->id;
			} else {
				$item->url = $item->link;
			}
			break;

		default :
			$router = JSite::getRouter();
			$item->url = $router->getMode() == JROUTER_MODE_SEF ? 'index.php?Itemid='.$item->id : $item->link.'&Itemid='.$item->id;
			break;
	}

	// Print a link if it exists
	if ($item->type != 'separator' && $item->url != null)
	{
		// Handle SSL links
		$iSecure = $iParams->def('secure', 0);
		if ($item->home == 1) {
			$item->url = JURI::base();
		} elseif (strcasecmp(substr($item->url, 0, 4), 'http') && (strpos($item->link, 'index.php?') !== false)) {
			$item->url = JRoute::_($item->url, true, $iSecure);
		} else {
			$item->url = str_replace('&', '&amp;', $item->url);
		}

		$result['link'] = $item->url;

		switch ($item->browserNav) {
			case 1:
				// _blank
				$result['href'] = 'href="'.$item->url.'" target="_blank"';
				$result['type'] = 'link_new';
				break;

			case 2:
				// window.open
				$attribs = 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes';
				$link = str_replace('index.php', 'index2.php', $item->url);
				$result['href'] = 'href="'.$link.'" onclick="window.open(this.href,\'targetWindow\',\''.$attribs.'\');return false;"';
				$result['type'] = 'link_popup';
				$result['link'] = $link;
				break;

			case 0:
			default:
				// _top
				$result['href'] = 'href="'.$item->url.'"';
				$result['type'] = 'link';
				break;
		}

		if ($result['type'] == 'text')
			$result['type'] = 'link';
	}

	return $result;
}


$db->setQuery("SELECT id, menutype, title FROM #__menu_types");
$menu_names = $db->loadObjectList('menutype');
if (empty($menu_names)) {
	$menu_names = array();
}

$db->setQuery("SELECT m.*, d.content FROM #__menu m LEFT JOIN #__dmenu_content AS d ON d.menu_id = m.id ORDER BY m.ordering");
global $items;
global $items_odd;
$items = $db->loadObjectList('id');
if (empty($items)) {
	$items = array();
}

$v_id = intval(JRequest::getCmd('id'));
$input_item = @$items[$v_id];

if ($input_item !== null) {
	if (!empty($_POST['hfrm_input'])) {
		if (isset($_POST['btn_delete'])) {
			if (!empty($items[$v_id]->content)) {
				$db->setQuery("DELETE FROM #__dmenu_content WHERE menu_id = $v_id");
				$db->query();
				$items[$v_id]->content = null;

				global $mainframe;
				$mainframe->enqueueMessage(JText::_('Card content deleted successfully'), 'message');
			}

			header('Location: ' . JRoute::_('index.php?option=' . $option . '&task=input', false));
			exit();
		}
		else if (isset($_POST['btn_cancel'])) {
			header('Location: ' . JRoute::_('index.php?option=' . $option . '&task=input', false));
			exit();
		}
		else if (isset($_POST['btn_save'])) {
			if (empty($items[$v_id]->content)) {
				$db->setQuery("INSERT INTO #__dmenu_content (menu_id, menutype, state, content) VALUES ($v_id, " . $db->Quote($items[$v_id]->menutype) . ", 1, " . $db->Quote($_POST['content']) . ")");
			}
			else {
				$db->setQuery("UPDATE #__dmenu_content SET content = " . $db->Quote($_POST['content']) . " WHERE menu_id = $v_id");
			}			

			$db->query();
			$items[$v_id]->content = $_POST['content'];
			
			global $mainframe;
			$mainframe->enqueueMessage(JText::_('Card content saved successfully'), 'message');
		}
	}

	if (empty($_POST['hfrm_input'])) {
		$_POST['content'] = (string) $items[$v_id]->content;
	}
}


echo '
<script type="text/javascript">

function copy(st) {
	var txt = document.getElementById("txt_copy");
	txt.value = st;
	txt.select();
	txt.focus();
}

function dmenu_keep_alive() {
	var noop_call = null;

	if (window.XMLHttpRequest) {
		noop_call = new window.XMLHttpRequest();
	}
	else if (window.ActiveXObject) {
		noop_call = new window.ActiveXObject("Microsoft.XMLHTTP");
	}

	if (noop_call) {
		var str = "option=' . $option . '&no_html=1&task=noop&' . DMENU_JS_SESSION_KEY . '=1";
		noop_call.open("POST", "index.php", true);
		noop_call.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		noop_call.setRequestHeader("Content-length", str.length);
		noop_call.setRequestHeader("Connection", "close");
		noop_call.send(str);
	}
	else {
		clearInterval(document.dmenu_keep_alive_timer);
	}
}

document.dmenu_keep_alive_timer = setInterval("dmenu_keep_alive()", 5000);

</script>

<table align="center">
	<tr>
		<td valign="top">
';

function iterate_menuitem($menutype, $item, $level) {
	global $items;
	global $items_odd;

	$items_odd = !$items_odd;
	$link = 'index.php?option=' . JRequest::getCmd('option') . '&task=input&id=' . $item->id;
	$info = load_menu_item($item);

	$name = htmlspecialchars($item->name);
	if (!empty($item->content)) {
		$name = '<strong>' . $name . '</strong>';
	}

	echo
'								<tr class="row' . ($items_odd ? '0' : '1') . '">
									<td align="center">' . $item->id . '</td>
									<td>' . str_repeat('&nbsp; &nbsp; ', $level) . '<a href="' . $link . '">' . $name . '</a></td>
									<td align="center"><img src="images/' . ($item->published ? 'tick.png' : 'publish_x.png') . '" alt="" /></td>
									<td>
										&nbsp; <input class="button" value="Page" type="button" onclick="copy(\'' . json_esc(JRoute::_($info['link'])) . '\');" />
										&nbsp; <input class="button" value="Submenu" type="button" onclick="copy(\'' . json_esc('::submenu::id=' . $item->id) . '\');" />
									</td>
								</tr>
';

	foreach ($items as $sub_item) {
		if ($sub_item->parent == $item->id) {
			iterate_menuitem($menutype, $sub_item, $level + 1);
		}
	}
}

if (empty($items)) {
	echo
'<p>' . JText::_('No menu items availabe') . '</p>
';
}
else {
	$open_menu_idx = 0;
	$sel_menutype = $input_item === null ? '' : $input_item->menutype;
	
	echo
'			<div id="menus" class="pane-sliders">
';

	$idx = -1;
	foreach ($menu_names as $menu) {
		$idx++;
		if ($menu->menutype == $sel_menutype) {
			$open_menu_idx = $idx;
		}
		
		echo
'				<div class="panel"><h3 class="jpane-toggler title" id="menu_' . $menu->id . '"><span>' . htmlspecialchars($menu->title) . '</span></h3><div class="jpane-slider content">
						<div class="menu_group_vgap"></div>
						
						<table class="adminlist" style="display:inline">
							<thead>
								<tr>
									<th class="title"> &nbsp; ' . JText::_('ID') . ' &nbsp; </th>
									<th class="title">' . JText::_('Title') . '</th>
									<th class="title">' . JText::_('Published') . '</th>
									<th class="title">&nbsp;</th>
								</tr>
							</thead>
							<tbody>
';

		$items_odd = false;
		foreach ($items as $item) {
			if ($item->menutype == $menu->menutype && $item->parent == 0) {
				iterate_menuitem($menu->menutype, $item, 0);
			}
		}

		echo
'							</tbody>
						</table>

						<div class="menu_group_vgap"></div>

				</div></div>
';
	}

	echo
'			</div>
';

	$document->addScriptDeclaration("
window.addEvent('domready', function(){ var JTooltips = new Tips($$('.hasTip'), { maxTitleChars: 50, fixed: false}); });
window.addEvent('domready', function(){ new Accordion($$('.panel h3.jpane-toggler'), $$('.panel div.jpane-slider'), {onActive: function(toggler, i) { toggler.addClass('jpane-toggler-down'); toggler.removeClass('jpane-toggler'); },onBackground: function(toggler, i) { toggler.addClass('jpane-toggler'); toggler.removeClass('jpane-toggler-down'); }, duration: 300, opacity: false, alwaysHide: true, display: " . $open_menu_idx . "}); });
");

}

echo
'		</td>
		<td> &nbsp; &nbsp; </td>
		<td valign="top">
			' . JText::_('Copy &amp; Paste link') . ' <input type="text" name="txt_copy" id="txt_copy" value="" size="80" />
			<br/>
			<br/>
			<br/>
';

if ($input_item === null) {
	echo
'			<p align="center">' . JText::_('Please select a menu item from the list') . '</p>
';
}
else {
	$editor =& JFactory::getEditor();
	echo
'			<form name="frm_input" method="post" action="">
				<input type="hidden" name="hfrm_input" value="' . microtime() . '" />
				<input type="hidden" name="option" value="' . JRequest::getCmd('option') . '" />
				<input type="hidden" name="task" value="input" />
				<input type="hidden" name="id" value="' . $v_id . '" />

				<div id="title">' . JText::sprintf('Card content of menu [%s] <strong>%s</strong>, from <strong>%s</strong>', $input_item->id, htmlspecialchars($input_item->name), htmlspecialchars($menu_names[$input_item->menutype]->title)) . '</div>
				<table align="center"><tr><td>
					' . $editor->display('content', @$_POST['content'], '', '', '90', '30') . '
				</td></tr></table>

				&nbsp;
				<p align="center">
					<input type="submit" name="btn_delete" value="' . JText::_('Delete') . '" onclick="return window.confirm(\'' . JText::_('Delete card content?\\n(Menu item will not be deleted)') . '\')" />
					&nbsp; &nbsp; <input type="submit" name="btn_cancel" value="' . JText::_('Cancel') . '" />
					&nbsp; &nbsp; <input type="submit" name="btn_save" value="' . JText::_('Save') . '" />
				</p>
			
			</form>
';
}

echo
'		</td>
	</tr>
</table>
';


?>